CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  
  _ByteLimit = 100
  _NoDelimiter = $FF
  
VAR
 
  byte rxString[_ByteLimit]
  byte PosOfDelimiter
  byte delimiter
  long length
  byte flashes[_ByteLimit]
  long ledFlasherStack[20]
OBJ
  pst : "Parallax Serial Terminal"
  strings : "Strings"
PUB Main | variableName, variableValue
  pst.Start(115_200)
  pst.Clear
  
  cognew(ledFlasher, @ledFlasherStack)
  
  repeat
    pst.Str(String(pst#NL, "Enter a name, then an equals sign and then their age: "))
    pst.StrIn(@rxString)
    pst.Str(String(pst#NL, pst#NL, "You typed ", 34))
    pst.Str(@rxString)
    pst.Char(34)
    pst.Char(pst#NL)
  
    PosOfDelimiter := DelimiterFinder(@rxString) 
    if PosOfDelimiter == _NoDelimiter
      pst.Str(String(pst#NL, "No delimiter found."))
    else  
      pst.Str(String(pst#NL, "Postion of delimiter is "))
      pst.Dec(PosOfDelimiter)
      pst.Str(String(pst#NL))
      length := strsize(@rxString)
      pst.Str(String(pst#NL, "length is "))
      pst.Dec(length)
      pst.Str(String(pst#NL)) 
      pst.Str(String(pst#NL, "variable name is ", 34))
      'variableName := strings.SubStr(@rxString, 0, PosOfDelimiter)             *DOES NOT WORK*
      bytemove(@variableName, strings.SubStr(@rxString, 0, PosOfDelimiter), (length - (length - PosOfDelimiter)))
      pst.Str(strings.SubStr(@rxString, 0, PosOfDelimiter))
      pst.Str(String(34, pst#NL))
      pst.Str(String(pst#NL, "variable value is ", 34))
      'variableValue := strings.SubStr(@rxString, PosOfDelimiter + 1, length)   *DOES NOT WORK*
      bytemove(variableValue, strings.SubStr(@rxString, PosOfDelimiter + 1, length), length - (PosOfDelimiter + 1))
      pst.Str(strings.SubStr(@rxString, PosOfDelimiter + 1, length))
      pst.Str(String(34, pst#NL))
      
    pst.Str(String(pst#NL))
    pst.Str(@variableName)
    pst.Str(String(pst#NL))
    
    if strcomp(@variableName, string("flashes"))
      pst.Str(String(pst#NL))
      pst.Str(String("It does contain ", 34, "flashes", 34))
      pst.Str(String(pst#NL, pst#NL))
      bytemove(@flashes, variableValue, strsize(variableValue))
      pst.Str(String("The variable ", 34, "flashes", 34, " is now set to ", 34))
      pst.Str(@flashes)
      pst.Str(String(34, pst#NL))


      
     
PUB DelimiterFinder(localPtr) | variableLength, foundFlag
  delimiter[0] := "="
  delimiter[1] := 0
  pst.Str(String(pst#NL, "Looking for delimiter ", 34))
  pst.Char(delimiter)
  pst.Str(String(34, " in string ", 34))  
  pst.Str(localPtr)
  pst.Char(34)
  pst.Char(pst#NL)
  variableLength := strsize(localPtr)
  foundFlag := 0
  repeat variableLength
    if byte[localPtr++] == delimiter
      foundFlag := 1
      quit
    result++
  if foundFlag == 0
    result := _NoDelimiter

  

PUB ledFlasher

  flashes := 1
  waitcnt((clkfreq * 2) + cnt)
  dira[23] := 1
  outa[23] := 0

  repeat
  
    repeat flashes
     
      outa[23] := 1
      waitcnt((clkfreq /2) + cnt)
      outa[23] := 0
      waitcnt((clkfreq /2) + cnt)
           
    waitcnt((clkfreq * 2) + cnt)  

                                              

'DAT
'delimiter     byte "="



  